/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.log.enums.YYLoggerTuJingEnum
 *  fire.pb.fushi.Module
 *  fire.pb.fushi.SSpotCardConfig
 *  fire.pb.item.Pack
 *  fire.pb.main.ConfigManager
 *  fire.pb.talk.MessageMgr
 *  fire.pb.tel.utils.TelBindUtils
 *  mkdb.Mkdb
 *  mkdb.Procedure
 *  mkdb.util.AutoKeys$AutoKeyLong
 *  mkio.Protocol
 *  org.apache.log4j.Logger
 *  xbean.Pod
 *  xbean.RoleTradingInfoList
 *  xbean.RoleUpdateModelNum
 *  xbean.TradingMap
 *  xtable.Roletradinginfolisttab
 *  xtable.Roleupdatemodelnumtab
 *  xtable.Tradingidtab
 */
package fire.pb.fushi.spotcheck;

import fire.log.enums.YYLoggerTuJingEnum;
import fire.pb.fushi.Module;
import fire.pb.fushi.SSpotCardConfig;
import fire.pb.fushi.spotcheck.PTradingSpotCardCenter;
import fire.pb.fushi.spotcheck.SBuySpotCard;
import fire.pb.fushi.spotcheck.SpotCheckManage;
import fire.pb.item.Pack;
import fire.pb.main.ConfigManager;
import fire.pb.talk.MessageMgr;
import fire.pb.tel.utils.TelBindUtils;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Map;
import mkdb.Mkdb;
import mkdb.Procedure;
import mkdb.util.AutoKeys;
import mkio.Protocol;
import org.apache.log4j.Logger;
import xbean.Pod;
import xbean.RoleTradingInfoList;
import xbean.RoleUpdateModelNum;
import xbean.TradingMap;
import xtable.Roletradinginfolisttab;
import xtable.Roleupdatemodelnumtab;
import xtable.Tradingidtab;

public class PBuySpotCard
extends Procedure {
    public static final Logger logger = Logger.getLogger((String)"CARD");
    private final long roleid;
    private final int buynum;
    private final int buyprice;
    public Map<Integer, SSpotCardConfig> sSpotCardConfig = ConfigManager.getInstance().getConf(SSpotCardConfig.class);

    public PBuySpotCard(long roleid, int buynum, int buyprice) {
        this.roleid = roleid;
        this.buynum = buynum;
        this.buyprice = buyprice;
    }

    protected boolean process() throws Exception {
        long costcp;
        if (Module.GetPayServiceType() != 1) {
            return false;
        }
        if (!SpotCheckManage.canOpenFun(this.roleid)) {
            MessageMgr.sendMsgNotify((long)this.roleid, (int)300011, null);
            return false;
        }
        if (TelBindUtils.isLimitByBindTel((long)this.roleid)) {
            StringBuilder sbd = new StringBuilder();
            sbd.append("role=").append(this.roleid).append(", 交易所买入道具错误！创建角色超出七天不绑定手机限制交易所");
            logger.error((Object)sbd.toString());
            return false;
        }
        if (this.buynum <= 0 || this.buyprice <= 0) {
            return false;
        }
        SSpotCardConfig sSpotCardConfigdata = this.sSpotCardConfig.get(1);
        if (sSpotCardConfigdata == null) {
            return false;
        }
        if (this.buynum < sSpotCardConfigdata.getBuynummin() || this.buynum > sSpotCardConfigdata.getBuynummax()) {
            return false;
        }
        if (this.buyprice < sSpotCardConfigdata.getBuypricemin() || this.buyprice > sSpotCardConfigdata.getBuypricemax()) {
            return false;
        }
        int max = SpotCheckManage.getRoleTradingMax();
        RoleTradingInfoList roleTradingInfoList = Roletradinginfolisttab.select((Long)this.roleid);
        if (roleTradingInfoList != null && roleTradingInfoList.getTradinglist().size() >= max) {
            MessageMgr.sendMsgNotify((long)this.roleid, (int)300008, null);
            return false;
        }
        int fushidaynummax = SpotCheckManage.getRoleTradingFushiMax();
        int oldbuynum = 0;
        RoleUpdateModelNum roleUpdateModelNum = Roleupdatemodelnumtab.get((Long)this.roleid);
        if (roleUpdateModelNum != null) {
            oldbuynum = roleUpdateModelNum.getTradingbuyfushinum();
            if (roleUpdateModelNum.getTradingbuyfushinum() >= fushidaynummax) {
                MessageMgr.sendMsgNotify((long)this.roleid, (int)191044, null);
                return false;
            }
        }
        if (oldbuynum + this.buynum > fushidaynummax) {
            String parans = fushidaynummax - oldbuynum + "";
            MessageMgr.sendMsgNotify((long)this.roleid, (int)191045, Arrays.asList(parans));
            return false;
        }
        double v = sSpotCardConfigdata.getTradingmoney() / 100.0 * (double)this.buynum * (double)this.buyprice;
        final long allgold = (long)Math.ceil((double)(this.buynum * this.buyprice) + v);
        if (allgold < 0L) {
            return false;
        }
        if (allgold > Integer.MAX_VALUE) {
            return false;
        }
        Pack bag = new Pack(this.roleid, false);
        if (bag.getGold() < allgold) {
            return false;
        }
        long cereditPoint = bag.getCurrency(13);
        if (cereditPoint + (costcp = (long)Math.round((float)allgold * Module.getCreditPointValue((int)14))) < 0L) {
            ArrayList<String> params = new ArrayList<String>();
            params.add("" + cereditPoint);
            params.add("" + (0L - (cereditPoint + costcp)));
            MessageMgr.sendMsgNotify((long)this.roleid, (int)180021, params);
            MessageMgr.sendSystemMessageToRole((long)this.roleid, (int)180026, null);
            return false;
        }
        if (bag.addSysCurrency(costcp, 13, "点卡交易 加金币", YYLoggerTuJingEnum.tujing_Value_spotcard, 0) != costcp) {
            return false;
        }
        if (bag.subGold(-allgold, "点卡交易挂单", YYLoggerTuJingEnum.tujing_Value_sellspotcard, 0) != -allgold) {
            MessageMgr.sendMsgNotify((long)this.roleid, (int)145005, null);
            return false;
        }
        if (roleUpdateModelNum == null) {
            roleUpdateModelNum = Pod.newRoleUpdateModelNum();
            Roleupdatemodelnumtab.insert((Long)this.roleid, (RoleUpdateModelNum)roleUpdateModelNum);
        }
        roleUpdateModelNum.setTradingbuyfushinum(roleUpdateModelNum.getTradingbuyfushinum() + this.buynum);
        logger.info((Object)(this.roleid + "买入，挂单，今天买入符石总数量" + roleUpdateModelNum.getTradingbuyfushinum()));
        final long time = System.currentTimeMillis();
        AutoKeys.AutoKeyLong autoKey = Mkdb.getInstance().getTables().getTableSys().getAutoKeys().getAutoKeyLong("SPOTCARD_UID");
        Long uId = (Long)autoKey.next();
        if (uId == null) {
            logger.error((Object)"点卡交易，生成主键错误");
            return false;
        }
        final String tradingid = this.roleid + "_" + this.buynum + "_" + this.buyprice + "_" + time + "_" + uId;
        Procedure proc = new Procedure(){

            protected boolean process() throws Exception {
                TradingMap tradingmap = Tradingidtab.get((Integer)1);
                if (tradingmap == null) {
                    tradingmap = Pod.newTradingMap();
                    Tradingidtab.insert((Integer)1, (TradingMap)tradingmap);
                }
                SpotCheckManage.addRoleTradingRecord(tradingid, PBuySpotCard.this.roleid, 0, PBuySpotCard.this.buynum, PBuySpotCard.this.buynum, PBuySpotCard.this.buyprice, time);
                SpotCheckManage.addcacheDesc(tradingid, PBuySpotCard.this.buyprice, PBuySpotCard.this.buynum, time, PBuySpotCard.this.roleid, tradingmap.getBuylist());
                logger.info((Object)(PBuySpotCard.this.roleid + "买入，挂单号" + tradingid + "\t单价" + PBuySpotCard.this.buyprice + "\t总数量" + PBuySpotCard.this.buynum + "\t挂单实际数量" + PBuySpotCard.this.buynum + "消耗总金币" + allgold));
                Procedure.pexecuteWhileCommit((Procedure)new PTradingSpotCardCenter());
                return true;
            }
        };
        Procedure.pexecuteWhileCommit((Procedure)proc);
        SBuySpotCard sBuySpotCard = new SBuySpotCard();
        PBuySpotCard.psendWhileCommit((long)this.roleid, (Protocol)sBuySpotCard);
        return true;
    }
}

